---
title: ScrollToOptions
slug: Web/API/ScrollToOptions
tags:
  - API
  - CSSOM View
  - Dictionary
  - Reference
  - ScrollToOptions
---
<div>{{ APIRef("CSSOM View") }}</div>

<p class="summary">The <strong><code>ScrollToOptions</code></strong> dictionary of the CSSOM View spec contains properties specifying where an element should be scrolled to, and whether the scrolling should be smooth.</p>

<p>A <code>ScrollToOptions</code> dictionary can be provided as a parameter for the following methods:</p>

<ul>
 <li>{{domxref("Window.scroll()")}}</li>
 <li>{{domxref("Window.scrollBy()")}}</li>
 <li>{{domxref("Window.scrollTo()")}}</li>
 <li>{{domxref("Element.scroll()")}}</li>
 <li>{{domxref("Element.scrollBy()")}}</li>
 <li>{{domxref("Element.scrollTo()")}}</li>
</ul>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("ScrollToOptions.top")}}</dt>
 <dd>Specifies the number of pixels along the Y axis to scroll the window or element.</dd>
 <dt>{{domxref("ScrollToOptions.left")}}</dt>
 <dd>Specifies the number of pixels along the X axis to scroll the window or element.</dd>
 <dt>{{domxref("ScrollToOptions.behavior")}}</dt>
 <dd>Specifies whether the scrolling should animate smoothly, or happen instantly in a single jump. This is actually defined on the <code>ScrollOptions</code> dictionary, which is implemented by <code>ScrollToOptions</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In our <a href="https://github.com/mdn/dom-examples/tree/master/scrolltooptions">scrolltooptions example</a> (<a href="https://mdn.github.io/dom-examples/scrolltooptions/">see it live</a>) we include a form that allows the user to enter three values — two numbers representing the left and top properties (i.e. the positions to scroll to along the X and Y axes), and a checkbox indicating whether they want smooth scrolling enabled or not.</p>

<p>When the form is submitted, an event handler is run that puts the entered values into a ScrollToOptions dictionary, and then invokes the {{domxref("Window.ScrollTo()")}} method, passing the dictionary as a parameter:</p>

<pre class="brush: js">form.addEventListener('submit', (e) =&gt; {
  e.preventDefault();
  var scrollOptions = {
    left: leftInput.value,
    top: topInput.value,
    behavior: scrollInput.checked ? 'smooth' : 'auto'
  }

  window.scrollTo(scrollOptions);
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('CSSOM View', '#dictdef-scrolltooptions', 'ScrollToOptions')}}</td>
   <td>{{Spec2('CSSOM View')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.ScrollToOptions", 10)}}</p>
</div>
